
# TP 1

Le but principal de ce TP est de comprendre comment mettre en oeuvre en C++ les principaux éléments du diagramme de classes UML.

Gardez le code ce TP pour la suite du cours car vous écrirez des tests pour valider votre code.
Chaque question est séparée donc veillez à créer un dossier pour chacune d'entre elles (ie ne modifiez pas le code d'une question précédente).


## Exercice 1 : Mise en oeuvre de l'association

In the folder `session-1`. Each question has its sub-folder.
The script `compilerun.sh` compiles all the code and runs the tests.

After `q1`, you can copy-paste the classes and tests created for `q1` into `q2` (etc.) to speed-up the coding tasks of the next questions.

For each question you have to write tests.


### Q1 Créer les classes `Velo` et `Guidon`.

Implement the following class diagram (class files already created).
Complete the test file to write tests.

![q4](./pics/q1.png)



### Q2 

On veut maintenant s'assurer que lorsque l'on ajoute un `Guidon` à un `Velo`, le `Velo` soit automatiquement ajouté au `Guidon` (principe d'intégrité référentielle) et qu'également le `Guidon` soit automatiquement ajouté au `Vélo`. Copier-coller les classes de la question 1 dans un nouveau dossier et apporter les modifications nécessaires.

### Q3

Supposons maintenant qu'un `Guidon` ne puisse plus avoir accès à son potentiel `Velo`. Copier-coller les classes de la question 1 dans un nouveau dossier et modifier les pour prendre en compte ce changement illustré par la figure suivante.

![q4](./pics/q3.png)



### Q4 

Une instance de `Velo` est liée à plusieurs instances de `Roue` (cf figure suivante). Créer les classes `Velo` et `Roue` et mettre en oeuvre l'association à liaison multiple. Il faut que le cas de test `testq4.java` fonctionne correctement.

![q4](./pics/q4.png)


## Exercice 2 : Mise en oeuvre de la composition

### Q5

Une instance de `Velo` *se compose* de plusieurs instances de `Roue` (cf figure suivante). Copier-coller les classes de la question 4 dans un nouveau dossier et modifier les pour prendre en compte la composition illustrée par la figure suivante. Penser à respecter l'intégrité référentielle du rôle `roues`.

![q4](./pics/q5.png)


## Exercice 3 : Mise en oeuvre de l'héritage


### Q6

Un pégase est à la fois un cheval et un oiseau (cf figure suivante).

![q4](./pics/q7.png)


### Q7: code coverage

Edit the script `compilerun.sh` to add code coverage (cf [./gtest-example/compilerun.sh](./gtest-example/compilerun.sh)). 

Improve your test suite to have a code coverage of 100%.